#include <machine.h>
#include <stdarg.h>
#include "iodefine.h"

char SCI_putc(unsigned char c);
short SCI_printf(char *string , ...);
short SCI_getc(unsigned char *c);


char SCI_putc(unsigned char c){
	//summary
	//  1M
	//parameter
	//	c : M
	//return
	//	0:error
	//	1:success

	unsigned long i;
	
	for(i=0;i<2000000;i++){
		if(SCI1.SSR.BIT.TEND){					//tOmF
			SCI1.TDR = c;					//Mf[^
			return 1;
		}
	}
	return 0;							//^CAEg
}


static void int_to_Dec(unsigned long n, char *buf){
	//summary
	//	lLN^i10i@jɕϊ
    char c;
    short length = 0;
    short i, half;

    do{
        if(n == 0)  i = 0;
        else        i = n % 10;
        buf[length] = (char)(i + '0');
        length++;
        n /= 10;
    }while(n != 0);

												    // ̕я𒼂
    half = length >> 1;
    for(i=0; i < half; i++){
        c = buf[i];
        buf[i] = buf[(length-1)-i];
        buf[(length-1)-i] = c;
    }
    buf[length]='\0';								//I[R[h
}

// --------------------------------------------------------
//  l16iϊ
// --------------------------------------------------------
static void int_to_Hex(unsigned long n, short upper, char *buf){
	//summary
	//	lLN^i16i@jɕϊ
    char c;
    char a = 'a';
    short len = 0;
    short i, half;

    // 啶/̐ݒ
    if(upper) a = 'A';
    
    // 16i֕ϊJEg
    do{
        i = n & 0x0F;
        if(i > 9)  buf[len] = (unsigned char)(i + a - 10);
        else       buf[len] = (unsigned char)(i + '0');
        len++;
        n >>= 4;
    }while(n != 0);

    // ̕я𒼂
    half = len >> 1;
    for(i=0; i < half; i++){
        c = buf[i];
        buf[i] = buf[(len-1)-i];
        buf[(len-1)-i] = c;
    }

    buf[len]='\0';   								//I[R[h̑} 
}

static char *PrintFormat(char *format,void *value){
	//summary
	//  %5d@ȂǁAlw肵tH[}bgŏo͂
	//parameter
	//	-
	//return
	//	-
	short n = 0;							//
	short m = 0;							//̐
	short z = 0;							//0Ŗ߂邩ǂ̃tO
	short i = 0;							//Ɨpϐ
	char buf[12];
	char *ptr=buf;
	unsigned char length=0; 
	char base = ' ';

	if(*format=='0'){						//[Ŗ߂
		 z = 1;
		 format++;
	}
	if((*format>='0')&&(*format<='9')){				//w
		n = *format-'0';
		format++;
	}

	switch(*format){
		case 'd':						//  10i(short^)
			if((signed short)value < 0){			//
				m = 1;
				int_to_Dec((unsigned long)(-(signed short)value) ,buf); 
			}
			else
			{
				int_to_Dec((unsigned long)value , buf);
			}
			break;
		case 'l': 						//  10i(long^)
			if((signed long)value < 0){			//
				m = 1;
				int_to_Dec((unsigned long)(-(signed long)value) ,buf); 
			}
			else
			{
				int_to_Dec((unsigned long)value , buf);
			}
			break;
		case 'u':   						// Ȃ 10i
			int_to_Dec((unsigned short)value ,buf);
			break;
		case 'x':   						// Ȃ 16 iB"abcdef" gpB
			int_to_Hex((unsigned long)value ,0 ,buf);
			break;
		case 'X':   						// Ȃ 16 iB"ABCDEF" gpB
			int_to_Hex((unsigned long)value ,1 ,buf);
			break;
		case 's':   						// Stringo
			ptr = (char *)value;
			break;
		case 'c':   						// 1byte
			buf[0] = (char)((unsigned long)value & 0xFF);
			buf[1] = '\0';					//I[R[h
			break;
		default: 
			buf[0] = '\0';					//I[R[h
			break;
	}
	
									//\
	if(m){length ++;}						//̏ꍇ
	for(;buf[length]!='\0';length++){}				//̃JEg
	if(n>length){n -=length;}					//̒
    else{n  = 0;}

	if(z){								//OŖ߂ꍇ
        base = '0';
        if(m){	        						// }CiX\
            SCI_putc('-');
            m = 0;
			length --;
        }
	}
    for(i=0; i<n; i++){							//킹
	    SCI_putc(base);
	}
    if(m){								//}CiX̕\
		SCI_putc('-');
		length --;
	}
	for(i=0;i<length;i++){						//f[^̕\
		if(!SCI_putc(buf[i])) break;
	}

	format++;
	return(format);
}

short SCI_printf(char *string , ...){
	//summary
	//  ȈՕ񑗐M
	//parameter
	//	A
	//return
	//	0:	error
	//	else:M
	va_list ap;
	char *ptr;

	unsigned long value = 0;
	
	ptr = string;
	va_start(ap,string);
	for(;;){
	    while (*ptr != '%') {					//ʂ̕𑗐M
	      if (!*ptr) {						//SM
	        va_end (ap);
	        return (ptr-string);					//MԂ
	      }
		  else {
			SCI_putc(*ptr);					//1M
			ptr++;
	      }
	    }
		ptr++;							//%ɑŔf
		if(*ptr=='%'){ SCI_putc('%'); ptr++;	}		//%%  -> %ƕ\
		else{
			ptr = PrintFormat(ptr,va_arg(ap,void *));
			if(ptr == 0) return 0;
		}
	
	}
}